#ifndef __RYUZ_H8_LIB_H_
#define __RYUZ_H8_LIB_H_

#include "h8_3048.h"


/* SCI̿® (16MHzΤȤ) */
#define SCI_2400   207
#define SCI_4800   103
#define SCI_9600    51
#define SCI_19200   25
#define SCI_31250   15
#define SCI_38400   12
#define SCI_57600    8		/*  -3.5% */


/* Waitؿΰ sec ľޥ */
#define Wait_usec(x)  Wait((x - 2) * 2)


/*  */
void di(void);	/* ߶ػ */
void ei(void);	/* ߵ */
void load_ccr(unsigned char newccr);	/* CCR */
unsigned char store_ccr(void);			/* CCRȥ */
void Wait(unsigned long tm);	/*  tm * 500ns + 2us */


/* SCI0 */
void SCI0_Init(unsigned char rate);	/* SCI */
void SCI0_Int_Char(void);			/* ǡ ߥϥɥ */
void SCI0_Int_Err(void);			/* 顼 ߥϥɥ */
void SCI0_Int_Empty(void);			/* Хåե */
void SCI0_Putc(char c)			;	/* ʸ */
int  SCI0_Getc(void);				/* ʸ */
void SCI0_Puts(const char* str);	/* ʸ */
void SCI0_Gets(char* buf);			/* ʸ */

/* SCI1 */
void SCI1_Init(unsigned char rate);	/* SCI */
void SCI1_Int_Char(void);			/* ǡ ߥϥɥ */
void SCI1_Int_Err(void);			/* 顼 ߥϥɥ */
void SCI1_Int_Empty(void);			/* Хåե */
void SCI1_Putc(char c)			;	/* ʸ */
int  SCI1_Getc(void);				/* ʸ */
void SCI1_Puts(const char* str);	/* ʸ */
void SCI1_Gets(char* buf);			/* ʸ */

/* SCIΥǥեȤΥͥؤޥ */
#ifndef USE_SCI1
	#define SCI_Init  SCI0_Init
	#define SCI_Putc  SCI0_Putc
	#define SCI_Getc  SCI0_Getc
	#define SCI_Puts  SCI0_Puts
	#define SCI_Gets  SCI0_Gets
#else
	#define SCI_Init  SCI1_Init
	#define SCI_Putc  SCI1_Putc
	#define SCI_Getc  SCI1_Getc
	#define SCI_Puts  SCI1_Puts
	#define SCI_Gets  SCI1_Gets
#endif


#endif /* __RYUZ_H8_LIB_H_ */
