#
#	asmconv.sed
#		by Noriyuki Hosobuchi
#
#	[usage:] sed -f asmconv.sed < infile > outfile
#
1i\
		.h8300h
s/H'/0x/
s/B'/0b/
s/\([a-zA-Z][a-zA-Z_0-9]*\)[ 	][ 	]*equ[ 	][ 	]*\([^ 	;][^ 	;]*\)/		\.equ	\1, \2/
s/^.*extern/#&/
s/public/\.global/
s/^[ 	][ 	]*end/		\.end/
s/INCLUDE(\([^)][^)]*\))/\.include \"\1\"/
s/segment[ 	][ 	]*TEXT/\.section .text/
s/segment[ 	][ 	]*DATA/\.section .data/
s/segment[ 	][ 	]*BSS/\.section .bss/
s/ds\.b[ 	][ 	]*\([^ 	][^ 	]*\)/.space	\1/
s/ds\.w[ 	][ 	]*\([^ 	][^ 	]*\)/.space	2\*\1/
s/ds\.l[ 	][ 	]*\([^ 	][^ 	]*\)/.space	4\*\1/
s/dc\.b/.byte/
s/CCR/ccr/
s/3048\.INC/3048\.inc/
s/\(bset.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bclr.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bnot.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(btst.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(band.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(biand.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bor.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bior.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bxor.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bld.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bild.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bst.*,[^ 	;][^ 	;]*\)/\1:8/
s/\(bist.*,[^ 	;][^ 	;]*\)/\1:8/
