OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("hos_start")
MEMORY
{
	vectors : o = 0x20000, l = 0x100
	rom    : o = 0x020100, l = 0xff00
	ram    : o = 0x030000, l = 0x10000
}
SECTIONS 				
{ 					
.vectors : {
	*(.vectors)
        }  > vectors
.text :	{ 					
	*(.text) 				
   	 _etext = . ; 
	}  > rom
.data : AT (ADDR(.text) + SIZEOF(.text)){
	DATA_rom = ADDR(.text) + SIZEOF(.text);
	DATA_start = .;
	*(.data)
	DATA_end = .;
	DATA_size_low = DATA_end - DATA_start;
	}  > ram
.bss : {
	BSS_start = .;
	*(.bss)
	BSS_end = .;
	BSS_size_low = BSS_end - BSS_start;
	}  >ram
	 _stack = . ; 
}
